unset $PROBLEMA
unset $NOME_PROBLEMA
unset $DIR_PROBLEMA
unset $EXT
unset $TIME_LIMIT
unset $ARQUIVO
unset $arq


EXT=`echo "$1" | cut -d. -f2 `
NOME_PROBLEMA=`echo "$1" | cut -d. -f1 `

case "$NOME_PROBLEMA" in 
	
	zipper) 

		PROBLEMA="A"
		DIR_PROBLEMA="$PROBLEMA"		
		TIME_LIMIT=1
		echo "Jugding problem $PROBLEMA ($NOME_PROBLEMA)..."			
		
	;;

	eleicao) 

		PROBLEMA="B"
		DIR_PROBLEMA="$PROBLEMA"		
		TIME_LIMIT=1
		echo "Jugding problem $PROBLEMA ($NOME_PROBLEMA)..."			
	;;
	
	sudoku) 

		PROBLEMA="C"
		DIR_PROBLEMA="$PROBLEMA"		
		TIME_LIMIT=1
		echo "Jugding problem $PROBLEMA ($NOME_PROBLEMA)..."			
	;;

	palavras) 

		PROBLEMA="D"
		DIR_PROBLEMA="$PROBLEMA"		
		TIME_LIMIT=1
		echo "Jugding problem $PROBLEMA ($NOME_PROBLEMA)..."			
	;;

	pedagios) 

		PROBLEMA="E"
		DIR_PROBLEMA="$PROBLEMA"		
		TIME_LIMIT=2
		echo "Jugding problem $PROBLEMA ($NOME_PROBLEMA)..."			
	;;

	cadernos) 

		PROBLEMA="F"
		DIR_PROBLEMA="$PROBLEMA"		
		TIME_LIMIT=1
		echo "Jugding problem $PROBLEMA ($NOME_PROBLEMA)..."			
	;;

	*)

		echo "Nome do programa errado!!!"	
		exit 1
	;;
esac

mv $1 $DIR_PROBLEMA
cd $DIR_PROBLEMA

case $EXT in


	hs)
	
		echo "Compilando em haskell..."
		ghc $NOME_PROBLEMA.hs -o saida -lm
		if [ "$?" != "0" ]; then
			echo "Compilation error"
			exit 1
		fi
#		chmod 777 saida
		echo "Compilação terminada. Pressione uma tecla..."		
		read
		echo "Executando em Haskell. Tempo maximo: $TIME_LIMIT seg."		
		echo "Comparando as saídas..."			
 		for ARQUIVO in input/*
        do
        	start=`date +%s`
			./saida  < $ARQUIVO > $NOME_PROBLEMA.out
			end=`date +%s`
			runtime=$((end-start))
			if [ $TIME_LIMIT -lt $runtime ]; then
				echo "Timelimit exceeded: $runtime seg."
				exit 0
			fi
			arq=`echo "$ARQUIVO" | cut -d/ -f2 `
			diff output/$arq $NOME_PROBLEMA.out
			a1="output/$arq"
			a2=$NOME_PROBLEMA.out
			diff -q "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff \"$a1\" \"$a2\" # files match"
  				echo "Files match exactly"
  				continue
			fi
			diff -q -b "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c "$a1" "$a2"
  				echo "Files match with differences in the amount of white spaces"
  				break
			fi
			diff -q -b -B "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b -B \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b "$a1" "$a2"
  				echo "Files match with differences in the amount of white spaces and blank lines"
  				break
			fi
			diff -q -i -b -B "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -i -b -B \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b -B \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b -B "$a1" "$a2"
  				echo "Files match if we ignore case and differences in the amount of white spaces and blank lines"
  				break
			fi
			diff -q -b -B -w "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b -B -w \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -i -b -B \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -i -b -B "$a1" "$a2"
  				echo "Files match if we discard all white spaces"
  				break
			fi
			diff -q -i -b -B -w "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -i -b -B -w \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b -B -w \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b -B -w "$a1" "$a2"
  				echo "Files match if we ignore case and discard all white spaces"
  				break
			fi
			wd=`which wdiff`
			if [ "$wd" != "" ]; then
  				wdiff \"$a1\" \"$a2\" >/dev/null 2>/dev/null
  				if [ "$?" == "0" ]; then
    				echo -e "wdiff \"$a1\" \"$a2\" # files match"
    				echo -e "diff -c -i -b -B -w \"$a1\" \"$a2\" # files dont match - see output" 
    				diff -c -i -b -B -w "$a1" "$a2"
    				echo "BUT Files match if we compare word by word, ignoring everything else, using wdiff"
    				echo "diff has a bug that, if a line contains a single space, this is not discarded by -w"
    				break
  				fi
			fi
			echo -e "### files dont match - see output"
			diff -c -i -b -B -w "$a1" "$a2"
			echo "Differences found"
			break
        done
		rm $NOME_PROBLEMA.out
		rm $NOME_PROBLEMA.hs
        rm saida

	;;
	
	java)
	
		echo "Compilando em java..."
		javac $1
		if [ "$?" != "0" ]; then
			echo "Compilation error"
			exit 1
		fi

		echo "Compilação terminada. Pressione uma tecla..."		
		read		
		echo "Executando em java. Tempo maximo: $TIME_LIMIT seg."		
 		for ARQUIVO in input/*
        do
        	start=`date +%s`
			java $NOME_PROBLEMA < $ARQUIVO > $NOME_PROBLEMA.out
			end=`date +%s`
			runtime=$((end-start))
			if [ $TIME_LIMIT -lt $runtime ]; then
				echo "Timelimit exceeded: $runtime seg."
				exit 0
			fi
			arq=`echo "$ARQUIVO" | cut -d/ -f2 `
			diff output/$arq $NOME_PROBLEMA.out
			a1="output/$arq"
			a2=$NOME_PROBLEMA.out
			diff -q "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff \"$a1\" \"$a2\" # files match"
  				echo "Files match exactly"
  				continue
			fi
			diff -q -b "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c "$a1" "$a2"
  				echo "Files match with differences in the amount of white spaces"
  				break
			fi
			diff -q -b -B "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b -B \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b "$a1" "$a2"
  				echo "Files match with differences in the amount of white spaces and blank lines"
  				break
			fi
			diff -q -i -b -B "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -i -b -B \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b -B \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b -B "$a1" "$a2"
  				echo "Files match if we ignore case and differences in the amount of white spaces and blank lines"
  				break
			fi
			diff -q -b -B -w "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b -B -w \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -i -b -B \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -i -b -B "$a1" "$a2"
  				echo "Files match if we discard all white spaces"
  				break
			fi
			diff -q -i -b -B -w "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -i -b -B -w \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b -B -w \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b -B -w "$a1" "$a2"
  				echo "Files match if we ignore case and discard all white spaces"
  				break
			fi
			wd=`which wdiff`
			if [ "$wd" != "" ]; then
  				wdiff \"$a1\" \"$a2\" >/dev/null 2>/dev/null
  				if [ "$?" == "0" ]; then
    				echo -e "wdiff \"$a1\" \"$a2\" # files match"
    				echo -e "diff -c -i -b -B -w \"$a1\" \"$a2\" # files dont match - see output" 
    				diff -c -i -b -B -w "$a1" "$a2"
    				echo "BUT Files match if we compare word by word, ignoring everything else, using wdiff"
    				echo "diff has a bug that, if a line contains a single space, this is not discarded by -w"
    				break
  				fi
			fi
			echo -e "### files dont match - see output"
			diff -c -i -b -B -w "$a1" "$a2"
			echo "Differences found"
			break
			
        done
		rm $NOME_PROBLEMA.out
		rm $NOME_PROBLEMA.java
        rm $NOME_PROBLEMA.class

	;;

	cpp)

		echo "Compilando em C++..."		
		g++ $NOME_PROBLEMA.cpp -o saida -lm
		if [ "$?" != "0" ]; then
			echo "Compilation error"
			exit 1
		fi
#		chmod 777 saida
		echo "Compilação terminada. Pressione uma tecla..."		
		read
		echo "Executando em C++. Tempo maximo: $TIME_LIMIT seg."		
		echo "Comparando as saídas..."			
 		for ARQUIVO in input/*
        do
        	start=`date +%s`
			./saida  < $ARQUIVO > $NOME_PROBLEMA.out
			end=`date +%s`
			runtime=$((end-start))
			if [ $TIME_LIMIT -lt $runtime ]; then
				echo "Timelimit exceeded: $runtime seg."
				exit 0
			fi
			arq=`echo "$ARQUIVO" | cut -d/ -f2 `
			diff output/$arq $NOME_PROBLEMA.out
			a1="output/$arq"
			a2=$NOME_PROBLEMA.out
			diff -q "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff \"$a1\" \"$a2\" # files match"
  				echo "Files match exactly"
  				continue
			fi
			diff -q -b "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c "$a1" "$a2"
  				echo "Files match with differences in the amount of white spaces"
  				break
			fi
			diff -q -b -B "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b -B \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b "$a1" "$a2"
  				echo "Files match with differences in the amount of white spaces and blank lines"
  				break
			fi
			diff -q -i -b -B "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -i -b -B \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b -B \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b -B "$a1" "$a2"
  				echo "Files match if we ignore case and differences in the amount of white spaces and blank lines"
  				break
			fi
			diff -q -b -B -w "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b -B -w \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -i -b -B \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -i -b -B "$a1" "$a2"
  				echo "Files match if we discard all white spaces"
  				break
			fi
			diff -q -i -b -B -w "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -i -b -B -w \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b -B -w \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b -B -w "$a1" "$a2"
  				echo "Files match if we ignore case and discard all white spaces"
  				break
			fi
			wd=`which wdiff`
			if [ "$wd" != "" ]; then
  				wdiff \"$a1\" \"$a2\" >/dev/null 2>/dev/null
  				if [ "$?" == "0" ]; then
    				echo -e "wdiff \"$a1\" \"$a2\" # files match"
    				echo -e "diff -c -i -b -B -w \"$a1\" \"$a2\" # files dont match - see output" 
    				diff -c -i -b -B -w "$a1" "$a2"
    				echo "BUT Files match if we compare word by word, ignoring everything else, using wdiff"
    				echo "diff has a bug that, if a line contains a single space, this is not discarded by -w"
    				break
  				fi
			fi
			echo -e "### files dont match - see output"
			diff -c -i -b -B -w "$a1" "$a2"
			echo "Differences found"
			break
        done
		rm $NOME_PROBLEMA.out
		rm $NOME_PROBLEMA.cpp
        rm saida

	;;

	c)
		echo "Compilando em C..."		
		gcc $NOME_PROBLEMA.c -o saida -lm 
		if [ "$?" != "0" ]; then
			echo "Compilation error"
			exit 1
		fi
		
#		chmod 777 saida
		echo "Compilação terminada. Pressione uma tecla..."		
		read
	    echo "Executando em C. Tempo maximo: $TIME_LIMIT seg."	
        echo "Comparando as saídas..."				
 		for ARQUIVO in input/*
        do
        	start=`date +%s`
			./saida  < $ARQUIVO > $NOME_PROBLEMA.out
			end=`date +%s`
			runtime=$((end-start))
			if [ $TIME_LIMIT -lt $runtime ]; then
				echo "Timelimit exceeded: $runtime seg."
				exit 0
			fi
			arq=`echo "$ARQUIVO" | cut -d/ -f2 `
			diff output/$arq $NOME_PROBLEMA.out
			a1="output/$arq"
			a2=$NOME_PROBLEMA.out
			diff -q "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff \"$a1\" \"$a2\" # files match"
  				echo "Files match exactly"
  				continue
			fi
			diff -q -b "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c "$a1" "$a2"
  				echo "Files match with differences in the amount of white spaces"
  				break
			fi
			diff -q -b -B "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b -B \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b "$a1" "$a2"
  				echo "Files match with differences in the amount of white spaces and blank lines"
  				break
			fi
			diff -q -i -b -B "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -i -b -B \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b -B \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b -B "$a1" "$a2"
  				echo "Files match if we ignore case and differences in the amount of white spaces and blank lines"
  				break
			fi
			diff -q -b -B -w "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -b -B -w \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -i -b -B \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -i -b -B "$a1" "$a2"
  				echo "Files match if we discard all white spaces"
  				break
			fi
			diff -q -i -b -B -w "$a1" "$a2" >/dev/null 2>/dev/null
			if [ "$?" == "0" ]; then
  				echo -e "diff -c -i -b -B -w \"$a1\" \"$a2\" # files match"
  				echo -e "diff -c -b -B -w \"$a1\" \"$a2\" # files dont match - see output"
  				diff -c -b -B -w "$a1" "$a2"
  				echo "Files match if we ignore case and discard all white spaces"
  				break
			fi
			wd=`which wdiff`
			if [ "$wd" != "" ]; then
  				wdiff \"$a1\" \"$a2\" >/dev/null 2>/dev/null
  				if [ "$?" == "0" ]; then
    				echo -e "wdiff \"$a1\" \"$a2\" # files match"
    				echo -e "diff -c -i -b -B -w \"$a1\" \"$a2\" # files dont match - see output" 
    				diff -c -i -b -B -w "$a1" "$a2"
    				echo "BUT Files match if we compare word by word, ignoring everything else, using wdiff"
    				echo "diff has a bug that, if a line contains a single space, this is not discarded by -w"
    				break
  				fi
			fi
			echo -e "### files dont match - see output"
			diff -c -i -b -B -w "$a1" "$a2"
			echo "Differences found"
			break
			
        done
		rm $NOME_PROBLEMA.out
		rm $NOME_PROBLEMA.c
        rm saida

	;;

	*)

		echo "Extensão do programa errada!!!"	
	;;

esac
